//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "jpeg.hpp"
#include "gifimg.hpp"
#include <pngimage.hpp>
#include <Graphics.hpp>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

int Sx,Sy,Sx1,Sy1;
int Pflg,Setflg=0;
double L,LSet;
String FNAM,EXT;
TBitmap *bmp;
Graphics::TBitmap *BMP,*BMP0;

int X,Y;
struct
{
  int x;
  int y;
  int x1;
  int y1;
} XY[100];
int Num=1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N4Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y)
{

 Sx=X;
 Sy=Y;
 Pflg=255;

 Image1->Canvas->Pen->Mode=pmNot;
 Image1->Canvas->Brush->Style=bsClear;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y)
{
 if(Pflg==0) return;

 if(Pflg !=255)
  {
	Image1->Canvas->MoveTo(Sx, Sy);
	Image1->Canvas->LineTo(Sx1,Sy1);
  }

  Sx1=X;
  Sy1=Y;

 Image1->Canvas->MoveTo(Sx, Sy);
 Image1->Canvas->LineTo(Sx1,Sy1);
 Pflg=-1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y)
{
 if(Pflg==0)
  {
   return;
  }

 int l,p;
 AnsiString d;
 d=Label2->Caption;

 L=sqrt((Sx1-Sx)* (Sx1-Sx)+(Sy1-Sy)* (Sy1-Sy));
 Label4->Caption=L;
 XY[Num].x=Sx;
 XY[Num].y=Sy;
 XY[Num].x1=Sx1;
 XY[Num++].y1=Sy1;

 Pflg=0;

 if(Setflg==0) return;
	{
	 Label1->Caption=L/d.ToDouble();
	 l= Label1->Caption.Length();
	 p=Label1->Caption.Pos(".");
	 if(l>p+2)
	  { Label1->Caption=Label1->Caption.SubString(1,p+2);
		Label1->Caption=Label1->Caption+"mm";
	  }
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N5Click(TObject *Sender)
{
 int l,p;

 AnsiString d;
 d=Edit1->Text;
 LSet=L;

 Label2->Caption=LSet/d.ToDouble();

 l= Label2->Caption.Length();
 p=Label2->Caption.Pos(".");
 if(l>p+2)
	  {
		Label2->Caption=Label2->Caption.SubString(1,p+2);
	  }

 Setflg=255;



 Image1->Canvas->MoveTo(XY[0].x, XY[0].y);
 Image1->Canvas->LineTo(XY[0].x1,XY[0].y1);

 XY[0]=XY[Num-1];
 TForm1::CLEAR1Click(Sender);

 Num=1;
 Image1->Canvas->MoveTo(XY[0].x, XY[0].y);
 Image1->Canvas->LineTo(XY[0].x1,XY[0].y1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *Sender)
{
 int flg,i;
 String ws,hs;

 if(OpenDialog1->Execute())
  {
   Screen->Cursor=crHourGlass;

   FNAM = OpenDialog1->FileName;

   delete bmp;
   bmp = new Graphics::TBitmap();

   ScrollBox1->Enabled = true;
   Image1->Visible=true;
   ScrollBox1->Visible=true;

   EXT = ExtractFileExt(FNAM).UpperCase();

   if(EXT == ".JPG")
	{
	 TJPEGImage *jpg;
	 jpg=new TJPEGImage();

	 jpg->LoadFromFile(FNAM);
	 bmp->Assign(jpg);
	 Image1->Picture->Assign(bmp);
	  delete jpg;
	}
   if(EXT == ".BMP")
	{
	 bmp->LoadFromFile(FNAM);

	 Image1->Picture->Assign(bmp);

	}
   if(EXT == ".TIF")
	{
	 ScrollBox1->Enabled = false;
	 Image1->Visible=false;
	 ScrollBox1->Visible=false;

	 flg =255;

	}

   if(EXT == ".PNG")
	{
	 TPngImage *png;
	 png = new TPngImage();

	 png->LoadFromFile(FNAM);
	 bmp->Assign(png);
	 Image1->Picture->Assign(bmp);

	 delete png;
	}

  if(EXT == ".GIF")
	{
	 TGIFImage *gif;
	 gif = new TGIFImage();
	 gif->LoadFromFile(FNAM);

	 bmp->Assign(gif);
	 Image1->Picture->Assign(bmp);
	 delete gif;

	}

  if(EXT == ".ICO")
   {
	 ScrollBox1->Enabled = false;
	 Image1->Visible=false;
	 ScrollBox1->Visible=false;

	flg=255;

   }

	ScrollBox1->HorzScrollBar->Range=Image1->Picture->Bitmap->Width;
	ScrollBox1->VertScrollBar->Range=Image1->Picture->Bitmap->Height;
	if(Image1->Picture->Bitmap->Width<Form1->Width)
	 {
	  Image1->Align=alNone;
	  Image1->Width=Image1->Picture->Bitmap->Width;
	  Image1->Height=Image1->Picture->Bitmap->Height;
	 }
	else
	 {
	  Image1->Align=alClient;

	 }

	hs="  H"+IntToStr(Image1->Picture->Bitmap->Height);
	ws=" x W"+IntToStr(Image1->Picture->Bitmap->Width);
	X=Image1->Picture->Bitmap->Width;
	Y=Image1->Picture->Bitmap->Height;
	if(flg != 0)
	   Caption = ExtractFileName(OpenDialog1->FileName);
	else
	   Caption = ExtractFileName(OpenDialog1->FileName)+hs+ws;


 for(i=0;i<100;i++)
  {
   XY[i].x=0;
   XY[i].y=0;
   XY[i].x1=0;
   XY[i].y1=0;
  }
 Num=1;
 Pflg=0;

	Screen->Cursor=crDefault;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1Change(TObject *Sender)
{
 AnsiString d;
 d=Edit1->Text;
 if(d=="") return;

 if(Setflg !=0)
   Label2->Caption=LSet/d.ToDouble();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CLEAR1Click(TObject *Sender)
{
  int i;
  for(i=1;i<Num;i++)
  {
   Image1->Canvas->MoveTo(XY[i].x, XY[i].y);
   Image1->Canvas->LineTo(XY[i].x1,XY[i].y1);
  }
 Pflg=0;
 Num=1;
}
//---------------------------------------------------------------------------


